; To try sound system - play12_asm
; CALL asad,a,b,k,n
; where a is the address of a k-byte area of LH sounds
; and	b is the address of a k-byte area of RH sounds
; and n is the number of repeats - 1
;
; CALL asad+2 stops the sound
; CALL asad+4 sets the number of samples left to asad+6
;
;
; SETVEC is used for START2 and START3

SETVEC	MACRO	ENTRY
	MOVEA.L	$70,A3		Level 4 auto vector
	MOVEA.L	-(A3),A2		set the reqired vector to A2
	CMPI.L	#"SSSS",-(A3)	Is it the sound system?
	BNE	BAD_EXIT	---->
	TRAP	#0		to supervisor mode
	JSR	\1(A2)		do the job
	MOVE	#0,SR		back to user mode
	ENDM

	NOLIST
	IN	WIN1_SYS_EQUBAS_ASM
	LIST
	BRA	START1		send samples
	BRA	START2		kill sound
	BRA	START3		returns number of samples left
ANS	DS.L	3
START2	BRA	STARU2
START3	BRA	STARU3
START1	LEA	ANS+4,A0
	MOVEM.L	D1-2,(A0) 	addresses to ANS + 4
;
	MOVEA.L	$70,A3
	MOVEA.L	-(A3),A2
	CMPI.L	#"SSSS",-(A3)
	BNE	BAD_EXIT	---->
	LEA	ANS,A0
	MOVE.L	A2,(A0)		keep vector
	MOVE.L	D3,D6
	MOVE.L	D4,D7		count of times of block
	MOVEQ	#0,D5
	TRAP	#0
	JSR	8(A2)		prepare for multiple entry
L5	MOVEA.L	ANS+4,A0		start of LH space
	MOVEA.L	ANS+8,A4		start of RH space
	MOVE.L	D6,D4
	BRA	L1
L3	SWAP	D4		switch to low word (32767)
L	MOVE.B	(A0)+,(A1)+	 same byte . .
	MOVE.B	(A4)+,(A1)+	. . to left and right
L1	CMPA.L	A2,A1		Is buffer full? . .
	BGE	L2		. . yes (before time maybe)
L4	DBF	D4,L		count k pairs (low word)
	SWAP	D4		prepare to count high word . .
	DBF	D4,L3		. . count high word
	DBF	D7,L5
	BSET	#31,D5		mark "finished"
L2	MOVEA.L	ANS,A2
	JSR	$C(A2)		tell SSSS that samples were added
	TST.L	D5		finished? . .
	BMI	EXIT2		. . yes
	BSR	SZS		wait ? ticks . .
	MOVE.L	ANS,A2		 . . replace vector pointer . .
	TRAP	#0		. . to supervisor mode . .
	JSR	8(A2)		. . get new queue pointers . .
	BRA	L4		. . and try to finish this time.
EXIT1	TRAP	#0
EXIT2	MOVEA.L	ANS,A2
	MOVEQ	#128,D1
	MOVEQ	#128,D2
	JSR	4(A2)
	MOVE	#0,SR
	MOVEQ	#0,D0
EXIT	RTS
BAD_EXIT
	MOVEQ	#-15,D0
	BRA	EXIT
;
STARU2	SETVEC	$10
	BRA	EXIT1

STARU3	SETVEC	$14
	LEA	ANS,A0
	MOVE.L	D0,(A0)
	BRA	EXIT1

SREG	REG	D0-1/D3/A0
SUS	MOVEM.L	SREG,-(A7)
	MOVEQ	#-1,D1		this job
	MOVE.W	D0,D3		wait ? ticks
	SUBA.L	A1,A1		notify no-one
	MOVEQ	#MT_SUSJB,D0
	TRAP	#1		wait
	MOVEM.L	(A7)+,SREG
	RTS

SZS	JSR	$14(A2)
	MOVEA.L	(A7)+,A2		return address . .
	MOVE	#0,SR
	MOVE.L	A2,-(A7)		. . to the user stack
	DIVU.W	C400,D0
	BNE	SUS
	RTS


C400	DC.W	400
